]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- 1.511
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
46763914 11# compiler version
69bcfbf3 12%cc_version %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
de629430 13%cxx_version %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
46763914 14
69bcfbf3 15%__rm /bin/rm --interactive=never
36eccf0d 16
33040789 17# Build system path macros.
69bcfbf3
ER
18%__autoconf autoconf %{?debug:-Wall}
19%__automake automake -a -c -f --foreign
20%__autopoint autopoint --force
21
22# add parallel build flags: -jN
a5656a95 23#
0b810bc6
JR
24# if you want to disable parallel build do (replace %% with %)
25# echo '%%_smp_mflags %%{nil}' >> ~/.rpmmacros
a5656a95
JR
26#
27%__make make %{?_smp_mflags}
28%__scons scons %{?_smp_mflags}
29%__waf waf %{?_smp_mflags}
30%__cmake cmake %{?_smp_mflags}
31
32%_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
33 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
f93109a0 34
83094b62 35%__gettextize { \
8a995cff 36 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 37 gettextize --copy --force --no-changelog; \
97589b6e 38 else \
3241033b 39 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
40 fi; \
41 if [ ! -f po/Makevars ]; then \
3241033b 42 cp -f po/Makevars{.template,}; \
8a995cff 43 fi; \
8a995cff 44}
f93109a0 45
46%__glib_gettextize glib-gettextize --copy --force
47%__gnome_doc_common gnome-doc-common --copy
fb59e475 48%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 49%__gtkdocize gtkdocize --copy
50%__intltoolize intltoolize --copy --force
c26f1b59 51%__libtoolize libtoolize --copy --force --install
33040789 52
384e1b2b 53# Path to top of build area.
f5f7156a 54%_topdir %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
384e1b2b 55
81e450f7
ER
56# The number of cvs changelog entries kept when building package.
57%_buildchangelogtruncate 20
58
6a5eda77 59%dependencytracking %{nil}
3241033b 60
e5da9169
ER
61# Relations between package names that cause dependency loops
62# with legacy packages that cannot be fixed. Relations are
63# specified as
64# p>q
65# where package p has a Requires: on something that package q Provides:
66#
67# XXX Note: that there cannot be any whitespace within the string "p>q",
68# and that both p and q are package names (i.e. no version/release).
69%_dependency_whiteout %{nil}
70
810fa5c4 71#-----------------------------------------------------------------
72#
73# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
74# BuildRequires: awk
75# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 76#
77# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 78# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
79# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
98e7f050 80# %rpmcppflags = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
09a90176 81# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 82#
83# Regular expressions are supported, but to avoid some character be treated
84# as regular expression it must be escaped twice.
85
86%filter_out \
7b6f1112 87 for (i = 1; i in I; i++) { A=0; \
810fa5c4 88 for (f in F) { \
89 if (I[i] ~ "^" F[f] "$") A=1; \
90 }; \
91 if (!A) printf(I[i] FS); \
92 }
93
94%rpmcflags %(awk 'BEGIN {
95 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 96 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 97 %{filter_out}
98}')
99
100%rpmcxxflags %(awk 'BEGIN {
09a90176 101 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
102 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 103 %{filter_out}
104}')
105
98e7f050
AM
106%rpmcppflags %(awk 'BEGIN {
107 split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
108 split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
109 %{filter_out}
110}')
111
810fa5c4 112%rpmldflags %(awk 'BEGIN {
c05a0741 113 split("%{?optldflags}",I);
810fa5c4 114 split("%{?filterout_ld}",F)
115 %{filter_out}
116}')
117
25f52d1a 118# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
119# but, don't use it, better use gcc as linker
120%ld_rpmldflags %(awk 'BEGIN {
121 split("%{rpmldflags}",F);
122 for (f in F) {
123 s = F[f];
124 if (s ~ /^-Wl,/) {
125 s = substr(s,5);
126 gsub(/,/," ",s);
127 };
128 printf(s FS);
129 };
130}')
131
8ef644e5 132#-----------------------------------------------------------------
133#
134# Generate a command which cleans environment, leaving only the
135# most important variables.
136# If any spec requires any additional environment it should
137# redefine %_preserve_env in following manner:
138#
139# # ADDITIONAL_VAR is required because [a good reason here]
242da3b6 140# %define _preserve_env %_preserve_env_base ADDITIONAL_VAR
8ef644e5 141
242da3b6
JR
142%_preserve_env_base PATH HOME TMP TMPDIR
143%_preserve_env %_preserve_env_base
8ef644e5 144
e9c11f22 145%_clean_env env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
a363d727
ER
146 split("%{?_preserve_env:%_preserve_env}", P);
147 for (i in P) {
148 p = P[i];
149 if (ENVIRON[p]) {
e9c11f22 150 split( ENVIRON[p], V, "" );
151 val = p "=";
152 for ( j = 1; j in V; j++ ) {
153 v = V[j];
154 if ( v == q )
155 v = qq;
156 else if ( v == "\\"" )
157 v = q2q;
158 else if ( v == "\\\\" )
159 v = "\\\\\\\\";
160 else
e82fb4ab 161 gsub( "[^a-zA-Z0-9/:._-]", "\\"&\\"", v );
e9c11f22 162 val = val "" v;
163 }
164 printf( val " " );
8ef644e5 165 }
166 }
167}')
168
9c404149 169#-----------------------------------------------------------------
9f4ce098 170%configure2_13 { \
9c404149
AM
171 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
172 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
173 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 174 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 175 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 176 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
98e7f050 177 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
8983c4c4
AM
178 %{?__cc:CC="%{__cc}" ; export CC ; } \
179 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 180 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 181 --host=%{_target_platform} \
9c404149
AM
182 --prefix=%{_prefix} \
183 --exec-prefix=%{_exec_prefix} \
184 --bindir=%{_bindir} \
185 --sbindir=%{_sbindir} \
186 --sysconfdir=%{_sysconfdir} \
187 --datadir=%{_datadir} \
188 --includedir=%{_includedir} \
189 --libdir=%{_libdir} \
190 --libexecdir=%{_libexecdir} \
191 --localstatedir=%{_localstatedir} \
192 --sharedstatedir=%{_sharedstatedir} \
193 --mandir=%{_mandir} \
194 --infodir=%{_infodir} \
b6c5da52 195 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 196 %{dependencytracking} \
9c404149
AM
197}
198
89f4ca1f 199%__cmake /usr/bin/cmake
39b9534b
ER
200%cmake { \
201CC="%{__cc}" \
202CXX="%{__cxx}" \
203CFLAGS="%{rpmcflags}" \
204CXXFLAGS="%{rpmcxxflags}" \
12513dc1 205LDFLAGS="%{rpmldflags}" \
89f4ca1f
ER
206%{__cmake} \
207}
208
209# override __scons to add -j4 in your ~/.rpmmacros for parallel make
210%__scons /usr/bin/scons
211%scons { \
212%{__scons} \
5c76736d
ER
213 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
214 CFLAGS="${CFLAGS:-%rpmcflags}" \
215 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
216 FFLAGS="${FFLAGS:-%rpmcflags}" \
98e7f050 217 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
5c76736d
ER
218 %{?__cc:CC="%{__cc}"} \
219 %{?__cxx:CXX="%{__cxx}"} \
220 libsuffix=%{_lib} \
221 prefix=%{_prefix} \
39b9534b
ER
222}
223
6339d32d 224# waf. see waf.spec
89f4ca1f 225# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
226%__waf /usr/bin/waf
227%waf { \
6339d32d
ER
228CC="%{__cc}" \
229CXX="%{__cxx}" \
9e244007 230CPP="%{__cpp}" \
6339d32d
ER
231CFLAGS="%{rpmcflags}" \
232CXXFLAGS="%{rpmcxxflags}" \
233%{__waf} \
6339d32d
ER
234}
235
4a6b0d54 236#----------------------------------------------------------------
9bacbb5b 237#%configure_cache 0
fe6c4bdd 238%configure_cache_file %{buildroot}.configure.cache
73f832b3 239
e84cd836 240%configure {./configure \
4a6b0d54
AF
241 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
242 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 243 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 244 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 245 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
98e7f050 246 CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
8983c4c4
AM
247 %{?__cc:CC="%{__cc}"} \
248 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 249 --host=%{_target_platform} \
4a6b0d54
AF
250 --build=%{_target_platform} \
251 --prefix=%{_prefix} \
252 --exec-prefix=%{_exec_prefix} \
253 --bindir=%{_bindir} \
254 --sbindir=%{_sbindir} \
255 --sysconfdir=%{_sysconfdir} \
256 --datadir=%{_datadir} \
257 --includedir=%{_includedir} \
258 --libdir=%{_libdir} \
259 --libexecdir=%{_libexecdir} \
260 --localstatedir=%{_localstatedir} \
261 --sharedstatedir=%{_sharedstatedir} \
262 --mandir=%{_mandir} \
263 --infodir=%{_infodir} \
b6c5da52 264 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 265 %{dependencytracking} \
9bacbb5b 266 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
267}
268
b3b1397b
ER
269# overload to insert debuginfo package
270%prep \
271%if 0%{?_enable_debug_packages}\
272%{debug_package}\
273%endif\
274%%prep\
275%{nil}
276
9c404149 277# Location of autoconf macros
7f0f4a79 278%_aclocaldir %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
9c404149 279
e2804f99 280# Location of omf files
7f0f4a79 281%_omf_dest_dir %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
e2804f99 282
e987a186 283# Location of pkgconfig files
9a4e877a 284%_pkgconfigdir /usr/%{_lib}/pkgconfig
36219c36
JB
285# noarch pkgconfig files
286%_npkgconfigdir /usr/share/pkgconfig
e987a186 287
486b0b5f 288# Location of desktop files
289%_desktopdir /usr/share/applications
86dff2d0 290%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 291
481463e9 292# Location of pixmaps for applnk/desktop files
e1f0a822 293%_pixmapsdir /usr/share/pixmaps
9c404149 294
481463e9 295# Location of themable icons for applnk/desktop files
b36c8e2a 296%_iconsdir /usr/share/icons
297
e987a186
JB
298# Location of fonts directories
299%_fontsdir /usr/share/fonts
300
b3282f3f 301# Location of Gtk and associated libraries documentation
fe6c4bdd 302%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 303
fc4d7771 304# Location of KDE documentation
fe6c4bdd 305%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 306
5869828c 307# unsermake script
308%__unsermake /usr/share/unsermake/unsermake
309
9c404149 310# Current date
8cf161e2 311%date %(LC_ALL=C date +"%a %b %d %Y")
9c404149 312
9c404149
AM
313# Example files, programs, scripts...
314%_examplesdir /usr/src/examples
315
c8f7e820 316# Alternative kernel type/version
261729d9 317%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 318
8377d27d 319# The directory holding Linux kernel sources
261729d9 320%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 321
9c404149 322# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 323%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 324
8bf3719d 325
f5f7156a
ER
326%releq_kernel %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
327%releq_kernel_up %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
328%releq_kernel_smp() %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
730239f9
ER
329%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
330%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
331%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 332
410df6e8
ER
333# Requires name = version-release
334%requires_releq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
8cf161e2 335# Requires: name = version
91d2f1eb 336%requires_eq() %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
8cf161e2 337# Requires: name = version (version based on querying package %2)
0d3e64c0 338%requires_eq_to(r) %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
01a9f990 339
c94807f3 340%apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
b9d5d440 341
342# kernel version-release handling
95125403
ER
343%__kernel_ver %{expand:%%global __kernel_ver %( \\
344 Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
345 Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
346 echo ${Z:-ERROR}; \\
1a7d3518 347)}%__kernel_ver
95125403 348
c94807f3
ER
349%__kernel_rel %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
350%__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
351%_kernel_ver %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
352%_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
87be1cf0 353
6262f001
ER
354# `uname -r` to be used in @release field
355%_kernel_vermagic %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
356
e00dd7f6 357# sgml macros
3241033b
ER
358%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
359%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
360%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
361%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
362%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
363%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 364%docbook_sgmlcat_fix() { for l in \
365'' \
366' -- default decl --' \
367'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
368' -- hacks for opensp --' \
369'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
370'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
371'' \
372; do echo $l; done >> %1 \
373}
374
eea64748
ER
375# vim - "
376
4f044018
ER
377# minimum file size needed for compressed documents.
378# just smaller files than this get larger when compressed.
a88ae20f
ER
379# some stats:
380# - 0 byte file compressed was 25 bytes .gz
381# - 39 byte file was compressed as 57
382# - with test/test.spec@man 158 byte file was compressed also 158
383%_min_compress_bytes 159
4f044018 384
9c404149
AM
385#-----------------------------------------------------------------
386# find and gzip all files in %{_mandir} and %{infodir}
387#
388# Requires: xargs, find
389#
390#%no_install_post_compress_docs 1
391%__spec_install_post_compress_docs { \
53d5af13 392%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 393 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 394 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 395 echo "Compress man pages: $i"; \
4f044018
ER
396 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
397 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
398 find $RPM_BUILD_ROOT$i -type l | while read a; do \
399 m=$(readlink $a); \
400 rm -f $a; \
401 echo .so ${m##*/} > $a; \
402 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
403 done; \
4f044018 404 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
405 fi; \
406 done; \
728ad671
JB
407 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
408 echo "Compress info pages: %{_infodir}"; \
409 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
410 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
411 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 412 fi; \
53d5af13 413}; __spec_install_post_compress_docs } }
9c404149
AM
414
415#-----------------------------------------------------------------
416# Strip executable binaries and shared object files
417#
418# Requires: find, awk, strip, cut, xargs
419#
a2ad2754
JB
420# Special macros which affect this process:
421#%no_install_post_strip 1 # disable stripping at all
422#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
423#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
424#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
425#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
426#
9c404149 427%__spec_install_post_strip {%{!?debug: \
53d5af13 428%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 429if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
430 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
431 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
432 if [ "$modulelist" ]; then \
433 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 434 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
435 echo "$modulelist" | xargs -l512 chmod u+w; \
436 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
437 echo "DONE"; \
438 fi; \
eea64748 439 fi; \
0ac49134 440 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
441 if [ -n "$filelist" ]; then \
442 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
443 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
444 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 445 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 446 if [ -n "$elfexelist" ]; then \
4d5370ac 447 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
448 chmod u+w $elfexelist; \
449 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
450 echo "DONE"; \
451 fi; \
452 if [ -n "$elfsharedlist" ]; then \
4d5370ac 453 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
454 chmod u+w $elfsharedlist; \
455 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
456 echo "DONE"; \
457 fi; \
458 if [ -n "$archiveslist" ]; then \
4d5370ac 459 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
460 chmod u+w $archiveslist; \
461 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
462 echo "DONE"; \
463 fi; \
98a06bad 464 fi; \
0ac49134
ER
465 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
466 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
467 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 468 if [ -n "$filelist_all" ]; then \
4d5370ac 469 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 470 chmod u+w $filelist_all; \
f89ccb5f 471 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 472 echo "DONE"; \
9c404149 473 fi; \
f89ccb5f 474 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 475 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 476 chmod u+w $filelist_unneeded; \
f89ccb5f 477 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 478 echo "DONE"; \
8f74418b 479 fi; \
f89ccb5f 480 if [ -n "$filelist_debug" ]; then \
4d5370ac 481 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 482 chmod u+w $filelist_debug; \
f89ccb5f 483 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 484 echo "DONE"; \
9f0d4f36 485 fi; \
53d5af13 486fi; }; __spec_install_post_strip } } }
3241033b 487
fc5d7e20 488#-----------------------------------------------------------------
489# remove all RPATH from executable binaries and shared object files
490#
491# Requires: find, awk, cut, xargs, chrpath, uname
492#
a2ad2754
JB
493# Special macros which affect this process
494#%no_install_post_chrpath 1 # disable chrpath at all
495#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
496#
fc5d7e20 497%__spec_install_post_chrpath {%{!?debug: \
53d5af13 498%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 499if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 500 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 501 if [ -n "$files" ]; then \
d5517264 502 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 503 fi; \
98a06bad 504 if [ -n "$objs" ]; then \
4d5370ac 505 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
506 echo "$objs" | \
507 while read file; do \
508 rpath= ; \
509 chmod u+w "$file"; \
5541bf26 510 for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
eda6b510
AM
511 case $dir in \
512 '$ORIGIN' ) \
513 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
514 else rpath="$rpath:$dir" ; fi ; \
515 continue ; \
516 ;; \
517 esac ; \
f9abaddb
AM
518 newdir=$(readlink -m "$dir"); \
519 [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
98a06bad
ER
520 case $dir in \
521 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
522 echo "remove-rpath: $dir in $file"; \
523 ;; \
524 * ) \
525 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
526 else rpath="$rpath:$dir" ; fi ; \
527 ;; \
528 esac ; \
529 done ; \
530 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
531 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
532 done; \
533 fi; \
53d5af13 534fi; }; __spec_install_post_chrpath } } }
3241033b 535
d366d7e0
AM
536#-----------------------------------------------------------------
537# Find all shared object files with unresolved symbols. Warn
538# and terminate if any found (termination can be turned off by define).
539#%no_install_post_check_so 1
540%__spec_install_post_check_so { \
541 __spec_install_post_check_so() { \
542 fail=0; \
543 printf "Searching for shared objects with unresolved symbols..."; \
34906a2d 544 for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
7df9ddfc 545 LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
d366d7e0
AM
546 done ; \
547 echo " DONE"; \
14ae3117 548 %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
d366d7e0
AM
549}; __spec_install_post_check_so }}
550
d72c185f 551#-----------------------------------------------------------------
ccb8ae8d 552# Find and gzip all kernel modules
553#
554# Requires: find
555#
fe6c4bdd 556#%no_install_post_compress_modules 1
ccb8ae8d 557%__spec_install_post_compress_modules { \
53d5af13 558%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 559 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 560 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
561 if [ "$q" ]; then \
562 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
563 echo "$q" | xargs -r %{__gzip} -9nf; \
564 echo "DONE"; \
565 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
566 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
567 fi; \
3241033b 568 fi; \
53d5af13 569}; __spec_install_post_compress_modules } }
9c404149 570
ef64802f
ER
571# Remove common Perl files we don't package
572%__spec_install_post_perl_clean {\
573%{!?no_install_post_perl_clean: \
574%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
575} }
576
83094b62 577#-----------------------------------------------------------------
0e4cb4dd 578# Update GConf2 schemas
83094b62 579#
580# Requires: GConf2
581#
46885239 582%gconf_schema_install() \
307ac6c9
ER
583 umask 022; \
584 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
585 /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
f27cf2fd 586%{nil}
46885239 587
588%gconf_schema_uninstall() \
24336a54 589if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
3241033b 590 umask 022; \
24336a54
ER
591 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
592 /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 593fi; \
f93109a0 594%{nil}
595
596#-----------------------------------------------------------------
597# Update desktop MIME database
c0a4caa0 598# requires: desktop-file-utils
c3bcd10e 599%update_desktop_database() {{ \
f93109a0 600 umask 022; \
fb59e475 601 /usr/bin/update-desktop-database -q; \
c00bf95c
MB
602};} \
603%{nil}
f93109a0 604
c3bcd10e
ER
605%update_desktop_database_post %update_desktop_database
606
607%update_desktop_database_postun() {{ \
f27cf2fd 608if [ "$1" = "0" ]; then \
c00bf95c 609 %update_desktop_database \
f27cf2fd 610fi; \
c00bf95c
MB
611};} \
612%{nil}
f93109a0 613
fb59e475 614#-----------------------------------------------------------------
615# Update shared MIME info database
616# requires: shared-mime-info
617#
c3bcd10e 618%update_mime_database() {{ \
fb59e475 619 umask 022; \
620 /usr/bin/update-mime-database %{_datadir}/mime; \
c00bf95c
MB
621};} \
622%{nil}
fb59e475 623
624#-----------------------------------------------------------------
625# Update icon cache
626# requires: gtk+
627#
c3bcd10e 628%update_icon_cache() {{ \
fb59e475 629 umask 022; \
072f4b80 630 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
c00bf95c
MB
631};} \
632%{nil}
fb59e475 633
f93109a0 634#-----------------------------------------------------------------
635# Update scrollkeeper database
636# requires: scrollkeeper
637#
638%scrollkeeper_update_post() \
f93109a0 639 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 640%{nil}
f93109a0 641
642%scrollkeeper_update_postun() \
f27cf2fd 643if [ "$1" = "0" ]; then \
f93109a0 644 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 645fi; \
f93109a0 646%{nil}
647
9c404149
AM
648#-----------------------------------------------------------------
649# post %install sequence:
650# - autodeps exceptions
651# - compress all man and info pages,
652# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 653# - compress kernel modules if any
9c404149
AM
654
655###################################################################
656# Requires/Provides automation
3e202b06 657# exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
338726a6 658#
2892b5df
JB
659%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
660%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
661%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
662%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
663%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
c94807f3 664
338726a6
JB
665#%_noautocompressdoc %{nil}
666#
8f74418b
MM
667%_missing_doc_files_terminate_build 1%{nil}
668%_unpackaged_files_terminate_build %{nil}
8781dc74 669# (X)emacs support
d77dcb61 670%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
c94807f3
ER
671%_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
672%_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
25043cd4 673
02b58f60
JK
674%__php_provides %{nil}
675%__php_requires %{nil}
676%__perl_provides %{nil}
677%__perl_requires %{nil}
fa3497cd 678%__mono_provides %{nil}
679%__mono_requires %{nil}
25043cd4
AF
680
681# Perl specific macro definitions.
c94807f3
ER
682%perl_privlib %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
683%perl_archlib %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
684%perl_vendorlib %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
685%perl_vendorarch %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
686%perl_sitelib %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
687%perl_sitearch %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
25043cd4 688
45c00b39 689# Ruby
c94807f3
ER
690%__ruby /usr/bin/ruby
691%ruby_archdir %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
692%ruby_ridir %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
693%ruby_rubylibdir %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
694%ruby_vendorarchdir %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
695%ruby_vendorlibdir %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
696%ruby_sitearchdir %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
697%ruby_sitelibdir %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
751cfc9e 698%ruby_rdocdir /usr/share/rdoc
c94807f3 699%ruby_version %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
669604db
ER
700%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
701%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 702
7ccf7643 703%php_pear_dir /usr/share/pear
7813c433 704%php_data_dir /usr/share/php
c94807f3
ER
705%php_extensiondir %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
706%php_sysconfdir %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
707%php_includedir %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
25043cd4 708
0c5d1b9b 709# extract php/zend api versions
c94807f3
ER
710%php_major_version %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
711%php_api_version %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
712%php_pdo_api_version %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
713%php_debug %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
714%zend_module_api %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
715%zend_extension_api %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
716%zend_zts %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
c1b2705c
ER
717
718# helper macro
f952c0f3 719%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
720
721# macros for public use
722# for php extensions (php-pecl)
68b68193 723%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 724%{__php_api_requires zend_module_api} \
f952c0f3
ER
725%{__php_api_requires -v %php_major_version debug php_debug} \
726%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 727
c1b2705c
ER
728# for zend extensions
729%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 730%{__php_api_requires zend_extension_api} \
f952c0f3
ER
731%{__php_api_requires -v %php_major_version debug php_debug} \
732%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 733
934c685f
ER
734# for php pdo modules (php-pecl-PDO_*)
735%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
736
6c3b8203
ER
737# for using PHP post scripts. for PHP >= 5.0
738%php_webserver_restart \
739[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 740[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
741if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
742 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
743 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
744 %service -q php-fcgi restart \
745 fi \
746fi \
6c3b8203
ER
747%{nil}
748
749# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
750%php4_webserver_restart \
751[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 752[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
753if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
754 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
755 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
756 %service -q php-fcgi restart \
757 fi \
758fi \
6c3b8203
ER
759%{nil}
760
578e9248 761# X.org helper macros
434ab5a2
ER
762%__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
763%__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
764
c94807f3
ER
765%xorg_xserver_ansic_abi %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
766%xorg_xserver_extension_abi %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
767%xorg_xserver_font_abi %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
768%xorg_xserver_videodrv_abi %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
769%xorg_xserver_xinput_abi %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
578e9248 770
434ab5a2 771%requires_xorg_xserver_extension \
97486460
AM
772%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
773%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
774%{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
775%{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
434ab5a2
ER
776%{nil}
777
778%requires_xorg_xserver_xinput \
97486460
AM
779%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
780%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
781%{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
782%{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
434ab5a2
ER
783%{nil}
784
785%requires_xorg_xserver_font \
97486460
AM
786%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
787%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
788%{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
789%{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
434ab5a2
ER
790%{nil}
791
792%requires_xorg_xserver_videodrv \
97486460
AM
793%{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
794%{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
795%{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
796%{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
434ab5a2 797%{nil}
578e9248 798
25043cd4
AF
799# Python specific macro definitions.
800# python main version
2383a9da 801%py_ver %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
25043cd4
AF
802
803# directories
2383a9da 804%py_prefix %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
3241033b 805%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 806%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 807%py_incdir /usr/include/python%{py_ver}
7ccf7643 808%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 809%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 810%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
811
812# pure python modules compilation
3241033b 813%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 814
3241033b 815%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
816
817# Software written in Python language require Python with main version
e63cd81d 818%pyrequires_eq() Requires: %1
25043cd4 819
4bf34b55
AF
820# Python 3.x
821# python main version
822%__python3 python3.0
823%py3_ver %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
824
825# directories
826%py3_prefix %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
827%py3_libdir %{py3_prefix}/%{_lib}/python%{py3_ver}
828%py3_scriptdir %{py3_prefix}/share/python%{py3_ver}
829%py3_incdir /usr/include/python%{py3_ver}
830%py3_sitedir %{py3_libdir}/site-packages
831%py3_sitescriptdir %{py3_scriptdir}/site-packages
832%py3_dyndir %{py3_libdir}/lib-dynload
833
834# pure python modules compilation
835%py3_comp %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
836
837%py3_ocomp %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
838
f12c2314 839# Hardlink binary identical .pyc and .pyo files
f12c2314 840%__spec_install_post_py_hardlink {\
53d5af13 841%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f35a1d62
ER
842local a b c=0 t=0; \
843if [ -d "$RPM_BUILD_ROOT" ]; then \
844 find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
845 while read a; do \
846 b="${a%.pyc}.pyo"; \
847 if cmp -s "$a" "$b"; then \
848 ln -f "$a" "$b"; \
849 c=$((c + 1)); \
850 fi; \
851 t=$((t + 1)); \
852 done < __rpm_pyc; \
853 [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
854 rm -f __rpm_pyc; \
855fi; \
53d5af13 856}; __spec_install_post_py_hardlink } }
f12c2314 857
9227b3f9 858# remove python sources, so that check-files won't complain
f12c2314 859%py_postclean() \
0f82e280 860for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 861 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
862done \
863%{nil}
864
4bf34b55
AF
865%py3_postclean() \
866for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
867 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
868done \
869%{nil}
870
0fc5cff8 871# depmod macro
872%depmod() { \
f6148427 873umask 022; \
0fc5cff8 874if [ -e /boot/System.map-%1 ]; then \
3241033b 875 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 876else \
3241033b
ER
877 if [ -e /boot/System.map ]; then \
878 /sbin/depmod -a -F /boot/System.map %1; \
879 else \
880 /sbin/depmod -a %1; \
881 fi \
0fc5cff8 882fi; \
883}
884
2afc6e64 885# XMMS specific macros
c94807f3
ER
886%xmms_prefix %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
887%xmms_exec_prefix %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
888%xmms_version %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
889%xmms_datadir %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
890%xmms_plugindir %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
891%xmms_visualization_plugindir %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
892%xmms_input_plugindir %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
893%xmms_output_plugindir %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
894%xmms_effect_plugindir %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
895%xmms_general_plugindir %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
896
897%_target_base_arch %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
d1537778 898
848c0d68 899# user/group checking macros
900#
901# Usage:
902# %userremove myuser
903#
904%userremove /usr/lib/rpm/user_group.sh user del
905%groupremove /usr/lib/rpm/user_group.sh group del
906#
907# Usage:
908# if %usertestrm myuser; then
909# /usr/sbin/userdel -r myuser
910# Note:
911# use these macros only if you need to call userdel/groupdel with
912# a non-standard option or take an extra action; otherwise use the
913# %userremove/%groupremove macros
914#
915%usertestrm /usr/lib/rpm/user_group.sh user testrm
916%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
917# user group membership management macros
918#
919# Usage:
920# %addusertogroup myuser agroup
921#
922%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 923
924# banner support (useful in {pre,post}{,un} and triggers)
925#
926# Usage:
aa41c920 927# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 928# the banner text, the banner text
aa41c920
ER
929# the banner text, and following line
930#EOF
931# You can use any form of here-document, <<'EOF' <<-EOT will do.
932# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
933#
72fcfcb3 934# -a - append to the banner
a8b9562a 935# -e - send to stderr instead of stdout
628754cb 936# -n - no show banner (overrides -t)
937# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
938#
939# Tests:
940# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
941# rpm -E 'date | %banner -e banner' > m; sh -x m
942#
afb54f6c 943%banner(aent:) ( \
1b334fe4 944RPM_SCRIPTVERBOSITY=5 \
945[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
946if [ -x /usr/bin/banner.sh ]; then \
aa41c920 947 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 948else \
a8b9562a 949 CMD="cat%{-e: >&2}" \
1b334fe4 950fi \
276a7b45
ER
951eval $CMD %{?2:%2}%{?3: %3}) \
952%{nil}
628754cb 953
990bd03f 954# useradd/groupadd macros
4c73bc69 955# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
956#
957# Usage:
958# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
959# [-g initial_group] [-G group[,...]] login
960#
961# -u uid. REQUIRED
962# -g gid/group. REQUIRED
963# -s defaults to /bin/false
964# -d defaults to /usr/share/empty
965# -c No default
966# -r is accepted but ignored (it's always set)
6bd4c218 967# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
968# rpm specific flags
969# -P package name. defaults to %{name}
970#
90627280 971%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
972%{!-u:%{error:useradd: Required argument -u missing}} \
973%{!-g:%{error:useradd: Required argument -g missing}} \
974%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
975if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
976 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
977 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
978 exit 1 \
979 fi \
980else \
981 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
982 /usr/sbin/useradd \\\
b5a7d552 983 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
984 -u %{-u*} \\\
985 -r \\\
986 -d %{-d*}%{!-d:/usr/share/empty} \\\
987 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 988 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
989 -g %{-g*} \\\
990 %{-M} \\\
991 %{-G:-G %{-G*}} \\\
1aac682a 992 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 993 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
994fi;
995
90627280
ER
996# Usage:
997# %groupadd [-P package] [-g gid] group
998#
999# -g gid. REQUIRED
1000#
1001# Sample:
1002# %groupadd -P %{name}-base -g %{gid} %{name}
1003
1004%groupadd(g:P:rfo) \
9ba02ba9
ER
1005%{!-g:%{error:groupadd: Required argument -g missing}} \
1006%{!?1:%{error:groupadd: Required parameter group missing}} \
637962e6 1007if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
90627280
ER
1008 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1009 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1010 exit 1 \
1011 fi \
1012else \
1013 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 1014 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 1015 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 1016fi;
7cb77741 1017
7c50f037 1018# webapp macros
4c73bc69 1019# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
1020#
1021# The config is installed/removed inside trigger, this means that you can any
1022# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 1023# updated. if you don't need the config for various reason for specific
35663282
ER
1024# webserver, just remove the symlink from config directory using webapp
1025# program. the trigger will not recreate the symlink on upgrades. In other
1026# words the config is linked to webserver config directory on first install of
1027# PACKAGE or WEBSERVER.
1028#
7c50f037
ER
1029# Add package's webserver config to webserver webapps dir.
1030# Usage:
df979130 1031# %webapp_register WEBSERVER WEBAPP
35663282
ER
1032#
1033%webapp_register() \
1034%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1035if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1036 /usr/sbin/webapp register %1 %2\
1037fi\
694a8f2e 1038# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 1039if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 1040 %{expand:%service -q %%1 reload}\
35663282
ER
1041fi\
1042%{nil}
1043
1044# Remove package's config from webserver webapps dir.
35663282 1045# Usage:
531c0efc
ER
1046# %webapp_register [-f] WEBSERVER WEBAPP
1047%webapp_unregister(f) \
35663282
ER
1048%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1049# remove link if either of the packages are gone \
5d3a09a3 1050if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 1051 /usr/sbin/webapp unregister %1 %2\
16897aea 1052 %{expand:%service -q %%1 reload}\
35663282
ER
1053fi \
1054%{nil}
1055
462b26fa 1056# service macro.
4c73bc69 1057# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
1058#
1059# calls usual service restart on package %post, but skips the restart if
1060# administrator has disabled automatic service restarts in either global
1061# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1062#
462b26fa 1063# Usage:
7377b5ca 1064# %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 1065#
a0bbe604 1066# -q be silent when service isn't started (for scriplets restaring other package's services)
7377b5ca 1067# -n NOOP mode, do not actually restart service
462b26fa 1068#
7377b5ca
ER
1069# Requirements:
1070# BuildRequires: rpmbuild(macros) >= 1.268
1071# Requires: rc-scripts
1072# -n option:
1073# BuildRequires: rpmbuild(macros) >= 1.450
1074%service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
1075
1076
f9aa75bf
ER
1077# Java macros. based on jpackage macros.java
1078#
1079# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 1080%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
1081
1082# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 1083%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
1084
1085# Root directory for all Java VM/SDK/JRE's private things.
1086%_jvmprivdir %{_libdir}/jvm-private
1087
1088# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 1089%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
1090
1091# Root directory for all architecture independent parts of Java VM/SDK/JRE's
1092%_jvmdatadir %{_datadir}/jvm
1093
1094# Root directory for all configurations parts of Java VM/SDK/JRE's
1095%_jvmsysconfdir %{_sysconfdir}/jvm
1096
1097# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 1098%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
1099
1100# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 1101%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
1102
1103# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 1104%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
1105
1106# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 1107%_jnidir %{_libdir}/java
f9aa75bf 1108
c94807f3 1109%java_home %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
6aedae62 1110
a9254650 1111%ant JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
fe6c4bdd 1112%jar %{java_home}/bin/jar
c94807f3 1113%java %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
fe6c4bdd
ER
1114%javac %{java_home}/bin/javac
1115%javadoc %{java_home}/bin/javadoc
6aedae62 1116
fe6c4bdd 1117%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
1118
1119%jpackage_script() \
3ca65b87
ER
1120install -d $RPM_BUILD_ROOT%{_bindir}\
1121cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
1122#!/bin/sh\
1123#\
1124# %{name} script\
1125# JPackage Project <http://www.jpackage.org/>\
1126\
1127# Source functions library\
1128. %{_javadir}-utils/java-functions\
1129\
1130# Source system prefs\
3ca65b87 1131if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 1132 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
1133fi\
1134\
1135# Source user prefs\
3ca65b87
ER
1136if [ -f $HOME/.%{name}rc ]; then\
1137 . $HOME/.%{name}rc\
6aedae62
ER
1138fi\
1139\
1140# Configuration\
1141MAIN_CLASS=%1\
1142BASE_FLAGS=%2\
1143BASE_OPTIONS=%3\
3ca65b87 1144BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
1145\
1146# Set parameters\
1147set_jvm\
3ca65b87
ER
1148set_classpath $BASE_JARS\
1149set_flags $BASE_FLAGS\
1150set_options $BASE_OPTIONS\
6aedae62
ER
1151\
1152# Let's start\
3ca65b87 1153run "$@"\
6aedae62
ER
1154EOF
1155
06f11871
ER
1156# jpackage 1.7
1157# Directory for maven depmaps
1158#
1159%_mavendepmapdir /etc/maven
1160%_mavendepmapfragdir /etc/maven/fragments
1161
1162#
1163# add_to_depmap adds an entry to the depmap. The arguments are:
1164#
1165# %1 the original groupid
1166# %2 the original artifact id
1167# %3 the version
1168# %4 the new groupid
1169# %5 the new artifactid
1170#
1171
1172%add_to_maven_depmap() \
1173install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1174cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1175<dependency>\
1176 <maven>\
1177 <groupId>%1</groupId>\
1178 <artifactId>%2</artifactId>\
1179 <version>%3</version>\
1180 </maven>\
1181 <jpp>\
1182 <groupId>%4</groupId>\
1183 <artifactId>%5</artifactId>\
1184 <version>%3</version>\
1185 </jpp>\
1186</dependency>\
1187\
1188EOF\
1189%{nil}
1190
1191#==============================================================================
1192#
1193# update_maven_depmap updates the main maven depmap
1194#
1195%update_maven_depmap() \
1196echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1197if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1198cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1199fi\
1200echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1201
1202
59d3ebe9 1203# PEAR install macros
4c73bc69 1204# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1205#
1206# Usage:
f7ecf326 1207# %%pear_package_setup ...
dfce8b19 1208#
59d3ebe9 1209# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1210# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1211# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
f7ecf326
ER
1212# -D - pass -D to %setup (so the build dir is not removed)
1213# -c - register channel from local channel.xml file
dfce8b19
ER
1214#
1215# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1216# destination hierarchy. you should copy the tree to buildroot after
1217# patching/reorganizing with %%pear_package_install.
1218#
1219# additionally BUILDROOT is stripped from files and files are converted to UNIX
1220# line endings.
1221#
1222# the pear install process output is recorded to install.log, you should put it
8763f51e 1223# to %%doc for later debug or just for information.
dfce8b19
ER
1224#
1225# additionally additional-packages.txt is produced if it was detected that the
1226# package has optional dependencies. the file format is suitable of displaying
1227# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1228# automatically added for this file.
59d3ebe9
ER
1229
1230
1231# records install.log and transforms PEAR names to PLD Linux rpm package names.
1232%__pear_install_log \
1233tee install.log \
1234# make post message of optional packages \
f64d1bb2 1235grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
59d3ebe9
ER
1236if [ -s optional-packages.txt ]; then \
1237 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1238else \
1239 rm -f optional-packages.txt \
1240fi \
1241%{nil}
1242
1243# command invoking pear cli
1244%__pear /usr/bin/pear
1245
67a089ff 1246%pear_install(a:n:zD) \
59d3ebe9 1247%__pear \\\
f7ecf326 1248 -c %{builddir}/pearrc \\\
dfce8b19 1249 -d doc_dir=/docs \\\
f7ecf326
ER
1250 -d temp_dir=/tmp \\\
1251 -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
dfce8b19
ER
1252 -d bin_dir=%{_bindir} \\\
1253 -d data_dir=%{php_pear_dir}/data \\\
1254 -d test_dir=%{php_pear_dir}/tests \\\
1255 install \\\
59d3ebe9 1256 --packagingroot=%{builddir} \\\
dfce8b19
ER
1257 --offline \\\
1258 --nodeps \\\
1259 %{-f:--force} \\\
67a089ff 1260 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
b872fad7 1261 %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
67a089ff
ER
1262%{nil}
1263
1264# The main macro.
1265# using this macro will append optional-packages.txt to the nocompressdoc list
1266# as it's displayed to user after package install. and adding additional gzip
1267# dep is just waste ;)
f7ecf326 1268%pear_package_setup(a:n:zDc:) \
67a089ff
ER
1269%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1270%define builddir %{_builddir}/%{srcdir} \
1271%setup -q -c -T %{-D:-D} -n %{srcdir} \
1272%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1273%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
f7ecf326 1274%{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
67a089ff 1275%pear_install \
59d3ebe9
ER
1276%{-z:cd ..} \
1277cat %{-z:$_N/}.install.log | %__pear_install_log \
1278\
dfce8b19 1279# undos sources \
2a80e4cf 1280find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1281%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1282%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1283%{nil}
1284
7bef60e8 1285# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1286# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1287%pear_package_install() \
1288cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1289find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1290# help the developer out a little: \
1291if [ -f _noautoreq ]; then \
1292 echo "AutoReqdep detected:" \
1293 echo "_noautoreq $(cat _noautoreq)" \
1294fi \
1295%{nil}
1296
0d5dd00c
ER
1297
1298# Register OpenLDAP schema.
4c73bc69 1299# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1300#
1301# Usage:
1302# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1303#
1304# -d specify dependant schemas, separated by comma
1305#
1306%openldap_schema_register(d:) \
1307for schema in %*; do \
1308 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1309 %{__sed} -i -e " \
1310 /^include.*local.schema/{ \
1311 iinclude\\t $schema\
1312 } \
1313 " /etc/openldap/slapd.conf \
1314 fi \
1315done \
1316# enable dependant schemas \
1317if [ "%{-d*}" ]; then \
1318 %{__sed} -i -e ' \
1319 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1320 s/^#// \
1321 }' /etc/openldap/slapd.conf \
1322fi \
1323%{nil}
1324
1325# Unregister OpenLDAP schema.
4c73bc69 1326# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1327#
1328# Usage:
1329# %%openldap_schema_unregister %{schemadir}/horde.schema
1330#
1331%openldap_schema_unregister() \
1332for schema in %*; do \
1333 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1334 %{__sed} -i -e " \
1335 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1336 # for symmetry it would be nice if we disable enabled schemas in post, \
1337 # but we really can not do that, it would break something else. \
1338 " /etc/openldap/slapd.conf \
1339 fi \
1340done \
1341%{nil}
1342
b0bc2936 1343%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1344
dcc6baf7 1345
1346# Build modules for kernels 2.6
1347# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1348#
1349# Usage:
aa559e46 1350# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1351#
1352# remember that proper Makefile is still required
1353# Options:
990bd03f 1354# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1355# without .ko extension, may be placed in subdirectory
aa559e46 1356# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1357# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1358# -c -- do not execute make clean
dcc6baf7 1359# <additional arguments> -- all additional arguments will be passed to
1360# make modules
1361#
1362# Additional patching supported via here document. Try:
1363# %build_kernel_modules -m module <<'EOF'
1364# your patch script here
1365# EOF
1366# Don't use it unless patching depends on config options.
1367
1368# Developer note: don't touch it unless you know how to handle '\'.
1369# - \ in script expands to nothing
1370# - \\\ in script expands to \
566398b4 1371# - \\\ inside definition expands to nothing
dcc6baf7 1372# - \\\\\\\ inside definition expands to \
1373# - in last line \ has to touch arguments so arguments passing
1374# in new lines (using \) will be supported
1375
5a81d83e 1376%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1377%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1378 \
1379%define Opts \\\\\\\
1380%if "%{_target_base_arch}" != "%{_arch}" \\\
1381 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1382 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1383 %else \\\
1384 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1385 %endif \\\
1386%else \\\
88608ef7 1387 CC="%{kgcc}" \\\
dcc6baf7 1388%endif \
88608ef7 1389%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1390 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1391 \
e364bc26 1392%{?-C:cd %{-C*}} \
dcc6baf7 1393compile() { \
ba9de9b2
ER
1394 local L="<" PATCH_SH; \
1395 [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
dcc6baf7 1396 set -e -x \
730239f9 1397 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1398 \
730239f9 1399for cfg in ${cfgs:-dist}; do \
dcc6baf7 1400 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1401 \
c546f6fb 1402 rm -rf o \
68cfe9d9 1403 install -d o/include/linux o/arch/powerpc/lib \
dcc6baf7 1404 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1405 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1406 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1407 \
1408 set +x \
1409 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1410 set -x \
1411 \
c768535c 1412 %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?) \
dcc6baf7 1413 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1414 %{-p*} %{-P*} \\\
1415 %{MakeOpts} \
1416 %else \
1417 install -d o/include/config \
1418 touch o/include/config/MARKER \
588f1b0b 1419 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf \
dcc6baf7 1420 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1421 %endif \
1422 \
5a81d83e 1423 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1424 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
f635907b 1425 ${1+"$@"} \\\
5a81d83e 1426 M=$PWD %{MakeOpts}} \
f635907b 1427 \
dcc6baf7 1428 %{__make} -C %{_kernelsrcdir} modules \\\
1429 ${1+"$@"} \\\
1430 M=$PWD %{MakeOpts} \
1431 \
1432 for MODULE in {%{-m*},}; do \
1433 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1434 done \
1435done \
aa559e46 1436%{?-C:cd -} \
dcc6baf7 1437} \
1438compile %{*}\
1439%{nil}
1440
1441
1442# Install kernel modules built by %build_kernel_modules
1443# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1444#
1445# Usage:
1446# %install_kernel_modules -m <modules> -d <directory>
1447#
1448# Options:
990bd03f 1449# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1450# without .ko extension, may be placed in subdirectory
1451# -d <directory> (required) -- in what subdirectory modules should be
1452# installed (eg. misc, kernel/drivers/net)
1453# -s <suffix> -- suffix to use when installing modules, useful when module
1454# with same name exists in kernel already
1455# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1456# for defining aliases, only useful with -s
dcc6baf7 1457
1458%install_kernel_modules(m:d:s:n:) \
1459%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1460%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1461%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1462 \
1463%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1464%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1465 \
b279feda 1466__install_kernel_modules() { \
730239f9 1467local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1468 \
1469for MODULE in {%{-m*},}; do \
1470 [ -n "${MODULE}" ] || continue \
730239f9
ER
1471 for cfg in ${cfgs:-dist}; do \
1472 [ "$cfg" = smp ] && suf=smp || suf= \
1473 MNAME=${MODULE##*/} \
1474 install -D ${MODULE}-$cfg.ko \\\
1475 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1476 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1477 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1478 >> %{ModprobeD}$suf/%{-n*}.conf} \
1479 done \
dcc6baf7 1480done \
b279feda 1481} \
1482__install_kernel_modules \
dcc6baf7 1483%{nil}
1484
fa65356c 1485# patchset macros
4c73bc69 1486# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1487#
1488# Usage:
1489# %patchset_source -f <seq(1) format> <start> [<end>]
1490# %patchset_patch <start> [<end>]
1491#
1492# If <end> is omited, it is assumed to be <start>.
1493#
1494# For example in preamble:
1495# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1496# and in %prep:
1497# %patchset_patch 33 44
1498
1499# generate SourceX urls from range START STOP
1500# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1501# The sources start from 10000
e91610db 1502%patchset_source(f:b:) %(
44f733ef 1503 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1504 start=$(expr $base + %1);
1505 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1506 # we need to call seq twice as it doesn't allow two formats
1507 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1508 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1509 paste %{tmpdir}/__ps{1,2};
1510 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1511) \
1512%{nil}
fa65356c
ER
1513
1514# apply sources from %patchset_source
1515# -p specify -pX for %patch line
1516# -b base offset: defaults to 10000
1517%patchset_patch(f:p:b:) %(
44f733ef 1518 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1519 start=$(expr $base + %1);
1520 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1521 echo ": patchset_patch %1%{?2: to %2}";
1522 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1523) \
1524%{nil}
fa65356c 1525
5730b44b 1526# browser plugins v2
4c73bc69 1527# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1528#
1529# Usage:
1530# %browser_plugins_add_browser <name> -p <plugindir>
1531#
1532# <name> (required) -- name of the browser. usually %{name}.
1533# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1534# -b -- default blacklists
1535# -a <arch> override arch
5730b44b
ER
1536#
1537# Example:
1538# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1539
1540%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1541%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1542%update_browser_plugins /usr/sbin/update-browser-plugins || :
1543
02ebf70f 1544%browser_plugins_add_browser(p:b:a:) \
9efd458e 1545 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1546 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1547 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1548 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1549 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1550 %{-b:cat >> $blacklist_file %{-b*}} \
1551%{nil}
1552
ad17b654
ER
1553# Helper for LUA.
1554# split string separated by space into quoted list
1555#
4c73bc69 1556# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1557#
1558# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1559%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1560
1561# adjust /etc/shells by adding and removing shells from there
4c73bc69 1562# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1563#
1564# Usage:
d9b789d9
ER
1565# %post -p <lua>
1566# %lua_add_etc_shells /bin/sh /bin/pdksh
ad17b654 1567#
d9b789d9
ER
1568# %preun -p <lua>
1569# if arg[2] == 0 then
1570# %lua_remove_etc_shells /bin/bash /bin/rbash
1571# end
7377b5ca
ER
1572#
1573# Requirements:
d9b789d9
ER
1574# BuildRequires: rpmbuild(macros) >= 1.462
1575#
ad17b654 1576
d9b789d9 1577%lua_add_etc_shells() \
ad17b654
ER
1578t = {}\
1579f = io.open("/etc/shells", "r")\
1580if f then\
1581 for l in f:lines() do t[l]=l; end\
1582 f:close()\
1583end\
1584for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1585 if not t[s] then\
b8c0bc18 1586 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1587 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1588 end\
1589end\
1590%{nil}
1591
d9b789d9
ER
1592%lua_remove_etc_shells() \
1593t = {}\
1594f = io.open("/etc/shells", "r")\
1595if f then\
1596 for l in f:lines() do t[l]=l; end\
1597 f:close()\
1598end\
1599for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1600 print("Removing "..l.." from /etc/shells")\
1601 t[l] = nil\
1602end\
1603s=""\
1604for _, l in pairs(t) do\
1605 s=s..l.."\\n"\
1606end\
1607io.open("/etc/shells", "w"):write(s)\
1608%{nil}
1609
1610# Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1611#
1612# Author: Elan Ruusamäe <glen@pld-linux.org>
1613#
1614# Usage:
1615# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1616# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1617#
1618# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1619#
1620# Requirements:
1621# BuildRequires: rpmbuild(macros) >= 1.429
1622#
1623%add_etc_shells(p) %{-p:<lua>}\
1624%{expand:%%lua_add_etc_shells %*}\
1625%{nil}
1626
ad17b654 1627%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1628%{-p:if arg[2] == 0 then}\
d9b789d9 1629%{expand:%%lua_remove_etc_shells %*}\
750e19f4 1630%{-p:end} \
ad17b654
ER
1631%{nil}
1632
75bd6249
ER
1633# Check syntax for Python files
1634#
1635# Author: Elan Ruusamäe <glen@pld-linux.org>
1636# Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1637#
1638# Usage:
1639# %py_lint src
1640#
1641# Requirements:
1642# BuildRequires: python
1643# BuildRequires: rpmbuild(macros) >= 1.469
1644
1645%py_lint() \
1646__py_lint() { \
1647find "$@" -type f -name '*.py' | python -c ' \
1648import sys \
1649import compiler \
1650\
1651err = 0\
1652for f in sys.stdin: \
1653 fd = open(f.strip()) \
1654 c = fd.read() \
1655 fd.close() \
1656 try: \
1657 compiler.parse(c) \
1658 except SyntaxError, e: \
1659 print "py_lint: %s: %s" % (f.strip(), e) \
1660 err = err + 1\
1661\
1662if err: \
1663 print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1664 sys.exit(1) \
1665else: \
1666 print >> sys.stderr, "py_lint: Found no syntax errors." \
1667' \
1668}; __py_lint %* \
1669%{nil}
1670
59d3ebe9 1671# vim:ts=4 sw=4 noet syn=spec
This page took 0.594264 seconds and 4 git commands to generate.